package banco.conta;

public class CadastroContas {
	private ArrayContas contas;

	public CadastroContas(ArrayContas a) {
	  if (a == null) {
		throw new IllegalArgumentException("Argumento repositorioContas nulo");
	  }
	  this.contas = a;
	}

	public void atualizar(Conta c) throws ContaInexistenteException {
  	  contas.atualizar(c);
	}
	public void inserir(Conta c) throws ContaExistenteException{
          if(!contas.existe(c.getNumero())){
	    contas.inserir(c);
          }else{
	    throw new ContaExistenteException("Conta existente");
	  }
        }

	public void creditar(String n, double v) throws ContaInexistenteException{
	  Conta c = contas.procurar(n);
	  c.creditar(v);
	}

	public void debitar(String n, double v) throws ContaInexistenteException,
          SaldoInsuficienteException{

	  Conta c = contas.procurar(n);
	  c.debitar(v);
	}

	public void remover(String n) throws ContaInexistenteException{
  	  contas.remover(n);
	}

	public Conta procurar(String n) throws ContaInexistenteException{
	  return contas.procurar(n);
	}

	public void transferir(String origem, String destino, double val)
          throws ContaInexistenteException, SaldoInsuficienteException{

	  Conta o = contas.procurar(origem);
	  Conta d = contas.procurar(destino);
	  o.transferir(d,val);
	}

        public ColecaoContasIteravel procurarContas(String cpfCliente){
          return contas.procurarContas(cpfCliente);
        }
}
