package banco.gui;

import banco.fachada.*;
import banco.cliente.*;
import banco.conta.*;
import banco.util.Util;

public class MenuPrincipal {
  static Fachada fachada = Fachada.obterInstancia();
  public static void main(String[] args) {
    int opcao = -1;
    do{
      opcao = TelasGerais.telaInicial();
      switch(opcao){
        case 1 : manipularClientes();break;
        case 2 : manipularContas();break;
        case 3 : sair();
        default : System.out.println("Saindo do sistema");
      }
    }while(opcao != 3);
  }

  public static void manipularClientes(){
    int opcao = -1;
    do{
      opcao = TelasClientes.lerOpcaoCliente();
      switch(opcao){
        case 1: //cadastrar novo cliente
          Cliente novo = TelasClientes.lerCliente();
          try{
            fachada.inserirCliente(novo);
          }catch(ClienteExistenteException ex){
            System.out.println(ex.getMessage());
          }
          break;

        case 2: //remover
          String cpfRemover = TelasClientes.lerCpfCliente();
          try{
            fachada.removerCliente(cpfRemover);
          }catch(ClienteInexistenteException ex){
            System.out.println(ex.getMessage());
          }
          break;

        case 3: //atualizar
          String cpfAtualizar = TelasClientes.lerCpfCliente();
          Cliente atualizar = null;
          try{
            atualizar = fachada.procurarCliente(cpfAtualizar);
            TelasClientes.mostrarCliente(atualizar);
            String novoNome = TelasClientes.lerNomeCliente();
            atualizar.setNome(novoNome);
            fachada.atualizarCliente(atualizar);
          }catch(ClienteInexistenteException ex){
            System.out.println(ex.getMessage());
          }
          break;

        case 4: //procurar
          String cpfProcurar = TelasClientes.lerCpfCliente();
          Cliente proc = null;
          try{
            proc = fachada.procurarCliente(cpfProcurar);
            TelasClientes.mostrarCliente(proc);
          }catch(ClienteInexistenteException ex){
            System.out.println(ex.getMessage());
          }
          break;

        case 5: //retornar ao menu principal
          break;

        default: System.out.println("Opcao invalida");
      }
    }while(opcao != 5);
  }

  public static void manipularContas(){
    int opcao = -1;
    do{
      opcao = TelasContas.lerOpcaoConta();
      switch(opcao){
        case 1: //cadastrar nova conta
          Conta nova = TelasContas.lerConta();
          try {
            fachada.inserirConta(nova);
          }catch (ClienteInexistenteException ex) {
            System.out.println(ex.getMessage());
          }catch (ContaExistenteException ex) {
            System.out.println(ex.getMessage());
          }
          break;

        case 2: //remover
          String numRemover = TelasContas.lerNumeroConta();
          try {
            fachada.removerConta(numRemover);
          }catch (ContaInexistenteException ex) {
            System.out.println(ex.getMessage());
          }
          break;

        case 3: //creditar
          String numCreditar = TelasContas.lerNumeroConta();
          double valorCreditar = TelasContas.lerValor();
          try {
            fachada.creditar(numCreditar,valorCreditar);
          }catch (ContaInexistenteException ex) {
            System.out.println(ex.getMessage());
          }
          break;

        case 4: //debitar
          String numDebitar = TelasContas.lerNumeroConta();
          double valorDebitar = TelasContas.lerValor();
          try {
            fachada.debitar(numDebitar,valorDebitar);
          }catch (ContaInexistenteException ex) {
            System.out.println(ex.getMessage());
          }catch (SaldoInsuficienteException ex) {
            System.out.println(ex.getMessage());
          }
          break;

        case 5: //transferir
          String origem = TelasContas.lerNumeroConta();
          String destino = TelasContas.lerNumeroConta();
          double valorTrans = TelasContas.lerValor();
          try {
            fachada.transferir(origem,destino,valorTrans);
          }catch (ContaInexistenteException ex) {
            System.out.println(ex.getMessage());
          }catch (SaldoInsuficienteException ex) {
            System.out.println(ex.getMessage());
          }
          break;

        case 6: //procurar
          String numProcurar = TelasContas.lerNumeroConta();
          Conta procurada = null;
          try {
            procurada = fachada.procurarConta(numProcurar);
          }catch (ContaInexistenteException ex) {
            System.out.println(ex.getMessage());
          }
          break;

        case 7: //procurar contas de um cliente
          String cpf = TelasClientes.lerCpfCliente();
          ColecaoContasIteravel contas = null;
          contas = fachada.procurarContas(cpf);
          TelasContas.imprimirContas(contas);
          break;

        case 8: //retornar ao menu principal
          break;

        default: System.out.println("Opcao invalida");
      }
    }while(opcao != 8);
  }

  public static void sair(){

  }
}