package banco.gui;

import banco.conta.*;
import banco.cliente.*;
import banco.util.Util;

public class TelasContas {

  public static int lerOpcaoConta(){
    System.out.println("");
    System.out.println("1 - Cadastrar ");
    System.out.println("2 - Remover ");
    System.out.println("3 - Creditar ");
    System.out.println("4 - Debitar ");
    System.out.println("5 - Transferir ");
    System.out.println("6 - Procurar ");
    System.out.println("7 - Procurar contas de um cliente");
    System.out.println("8 - Retornar ");
    System.out.print("Escolha uma opcao: ");

    int opcao = Util.readInt();

    return opcao;
  }

  public static Conta lerConta(){
    System.out.print("Digite o numero da conta: ");
    String numero = Util.readStr();
    System.out.print("Digite o valor do saldo: ");
    double saldo = Util.readDbl();
    System.out.print("Dogite o tipo de conta (1-Conta 2-Poupanca 3-Conta Bonificada)");
    int tipo = Util.readInt();
    System.out.print("Digite o cpf do proprietario: ");
    String cpf = Util.readStr();

    Cliente cli = new Cliente(cpf,null);
    Conta c = null;
    switch(tipo){
      case 1 : c = new Conta(numero,saldo,cli);break;
      case 2 : c = new Poupanca(numero,saldo,cli);break;
      case 3 : c = new ContaBonificada(numero,saldo,cli);break;
      default : throw new RuntimeException("Tipo de conta invalido");
    }

    return c;
  }

  public static String lerNumeroConta(){
    System.out.print("Digite o numero da conta: ");
    String numero = Util.readStr();

    return numero;
  }

  public static double lerValor(){
    System.out.print("Digite o valor: ");
    double valor = Util.readDbl();

    return valor;
  }

  public static void mostrarConta(Conta c){
    System.out.println("TIPO DE CONTA: " + c.getClass().getName());
    System.out.println("NUMERO: " + c.getNumero());
    System.out.println("SALDO: " + c.getSaldo());
  }

  public static double lerSaldo(){
    System.out.print("Digite o saldo: ");
    double saldo = Util.readDbl();

    return saldo;
  }

  public static void imprimirContas(ColecaoContasIteravel contas){
    while(contas.hasNext()){
      Conta atual = contas.next();
      mostrarConta(atual);
    }
  }
}